*** gmpthres.3c0dbda7f526/mpz/divegcd.c	Sun Feb 20 19:33:38 2011
--- /home/tege/prec/gmpthres/mpz/divegcd.c	Sun Feb 20 19:26:27 2011
***************
*** 45,48 ****
--- 45,49 ----
  
  
+ #if GMP_NUMB_BITS % 2 == 0
  static void
  mpz_divexact_by3 (mpz_ptr q, mpz_srcptr a)
***************
*** 62,66 ****
  
        qp = PTR(q);
!       mpn_divexact_by3 (qp, PTR(a), abs_size);
  
        abs_size -= (qp[abs_size-1] == 0);
--- 63,67 ----
  
        qp = PTR(q);
!       mpn_bdiv_dbm1 (qp, PTR(a), abs_size, GMP_NUMB_MASK / 3);
  
        abs_size -= (qp[abs_size-1] == 0);
***************
*** 68,71 ****
--- 69,98 ----
      }
  }
+ #endif
+ #if GMP_NUMB_BITS % 4 == 0
+ static void
+ mpz_divexact_by5 (mpz_ptr q, mpz_srcptr a)
+ {
+   mp_size_t  size = SIZ(a);
+   if (size == 0)
+     {
+       SIZ(q) = 0;
+       return;
+     }
+   else
+     {
+       mp_size_t  abs_size = ABS(size);
+       mp_ptr     qp;
+ 
+       MPZ_REALLOC (q, abs_size);
+ 
+       qp = PTR(q);
+       mpn_bdiv_dbm1 (qp, PTR(a), abs_size, GMP_NUMB_MASK / 5);
+ 
+       abs_size -= (qp[abs_size-1] == 0);
+       SIZ(q) = (size>0 ? abs_size : -abs_size);
+     }
+ }
+ #endif
  
  void
***************
*** 85,88 ****
--- 112,116 ----
  	  return;
  	}
+ #if GMP_NUMB_BITS % 2 == 0
        if (dl == 3)
  	{
***************
*** 90,108 ****
  	  return;
  	}
  
        count_trailing_zeros (twos, dl);
        dl >>= twos;
  
        if (dl == 1)
  	{
- 	  mpz_tdiv_q_2exp (q, a, twos);
  	  return;
  	}
        if (dl == 3)
  	{
- 	  mpz_tdiv_q_2exp (q, a, twos);
  	  mpz_divexact_by3 (q, q);
  	  return;
  	}
      }
  
--- 118,155 ----
  	  return;
  	}
+ #endif
+ #if GMP_NUMB_BITS % 4 == 0
+       if (dl == 5)
+ 	{
+ 	  mpz_divexact_by5 (q, a);
+ 	  return;
+ 	}
+ #endif
  
        count_trailing_zeros (twos, dl);
        dl >>= twos;
+       mpz_tdiv_q_2exp (q, a, twos);
  
        if (dl == 1)
  	{
  	  return;
  	}
+ #if GMP_NUMB_BITS % 2 == 0
        if (dl == 3)
  	{
  	  mpz_divexact_by3 (q, q);
  	  return;
  	}
+ #endif
+ #if GMP_NUMB_BITS % 4 == 0
+       if (dl == 5)
+ 	{
+ 	  mpz_divexact_by5 (q, q);
+ 	  return;
+ 	}
+ #endif
+ 
+       mpz_divexact_ui (q, q, dl);
+       return;
      }
  
